# Copyright (C) 2006-2009 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

from TagObject import TagObject

TAG_NAME = "base_resource"  #This tag name should never be seen

class BaseResource(TagObject):
  def __init__(self):
    TagObject.__init__(self)
    self.TAG_NAME = TAG_NAME
    self.resource_type = ""
    self.deny_all_children = False
    self.refcount = 1
  
  def ref(self):
    self.refcount += 1
  
  def unref(self):
    self.refcount -= 1

  def getRefcount(self):
    return self.refcount

  def getResourceType(self):
    return self.resource_type

  def isDenyAll(self):
    return self.deny_all_children
