# Copyright (C) 2009-2010 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

# -*- coding: utf-8 -*-
"""The application's Globals object."""

from luci.controllers.scheme import LuciScheme
from luci.lib.form_utils import FormUtils
from luci.lib.ClusterConf.Totem import Totem

__all__ = ['Globals']



class Globals(object):
    """Container for objects available throughout the life of the application.

    One instance of Globals is created during application initialization and
    is available during requests via the 'app_globals' variable.

    """
    DEFAULT_CLUSTER_VERSION = 3

    def __init__(self):
        """Prepare some common static functions, constants etc."""
        self.form_utils = FormUtils
        self.scheme = LuciScheme
        self.totem = Totem
        self.data = None

